# coding: utf-8

"""
    DNL API

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: 1.3.58
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import os
import sys
import unittest

import cli_dnl
from cli_dnl.rest import ApiException
from cli_dnl.apis.agent_portal_api import AgentPortalApi
from .settings import *


class TestAgentPortalApi(unittest.TestCase):
    """ AgentPortalApi unit test stubs """

    def setUp(self):
        self.api = cli_dnl.apis.agent_portal_api.AgentPortalApi()

    def tearDown(self):
        pass

    def test_home_agent_all_rates_list_get(self):
        """
        Test case for home_agent_all_rates_list_get


        """
        a = auth_random_a()
        #print(a)

        ret = self.api.home_agent_all_rates_list_get(effective_date=str(datetime.now().date()))
        assert (ret.success)
        print(ret)
        pass

    def test_home_agent_client_and_gateway_payments_get(self):
        """
        Test case for home_agent_client_and_gateway_payments_get


        """
        a = auth_random_a()
        # print(a)

        ret = self.api.home_agent_client_and_gateway_payments_get()
        assert (ret.success)
        print(ret)
        pass

    def test_home_agent_client_balances_get(self):
        """
        Test case for home_agent_client_balances_get


        """
        a = auth_random_a(usage_count_gt=0)
        ret = self.api.home_agent_client_balances_get()
        assert (ret.success and len(ret.payload.items))
        pass

    def test_home_agent_client_client_id_gateway_payment_post(self):
        """
        Test case for home_agent_client_client_id_gateway_payment_post


        """
        a = auth_random_a(usage_count_gt=0)
        ret = self.api.home_agent_clients_get()
        assert (ret.success and len(ret.payload.items))
        items = ret.payload.items
        random.shuffle(items)
        from .test_finance_api import gateway_payment
        data=gateway_payment()
        print(data)
        ret = self.api.home_agent_client_client_id_gateway_payment_post(client_id=items[0].client_id,body=data)
        assert (ret.success)

        pass

    def test_home_agent_client_client_id_get(self):
        """
        Test case for home_agent_client_client_id_get


        """
        a = auth_random_a(usage_count_gt=0)
        ret = self.api.home_agent_clients_get()
        assert (ret.success and len(ret.payload.items))
        items=ret.payload.items
        random.shuffle(items)
        ret = self.api.home_agent_client_client_id_get(client_id=items[0].client_id)
        assert(ret.success)
        pass

    def test_home_agent_client_client_id_patch(self):
        """
        Test case for home_agent_client_client_id_patch


        """
        a = auth_random_a(usage_count_gt=0)
        ret = self.api.home_agent_clients_get()
        assert (ret.success and len(ret.payload.items))
        items = ret.payload.items
        random.shuffle(items)
        data = {'notify_client_balance':True}
        print(items[0].client_id)
        ret = self.api.home_agent_client_client_id_patch(client_id=items[0].client_id,body=data)
        assert (ret.success)
        pass

    def test_home_agent_client_create_post(self):
        """
        Test case for home_agent_client_create_post


        """
        from .test_carrier_api import data_full
        auth()
        data = data_full()
        a = auth_random_a()


        data['carrier_name'] = a.agent_name+'_client_'+data['carrier_name']
        ret = self.api.home_agent_client_create_post(body=data)
        assert(ret.success)
        pass

    def test_home_agent_client_and_gateway_payments_get(self):
        """
        Test case for home_agent_client_and_gateway_payments_get


        """
        a = auth_random_a(usage_count_gt=0)
        ret = self.api.home_agent_client_and_gateway_payments_get()
        assert (ret.success)
        print(ret)
        pass

    def test_home_agent_client_gateway_payments_get(self):
        """
        Test case for home_agent_client_gateway_payments_get


        """
        a = auth_random_a(usage_count_gt=0)
        ret = self.api.home_agent_client_gateway_payments_get()
        assert (ret.success)
        print(ret)
        pass

    def test_home_agent_client_payments_get(self):
        """
        Test case for home_agent_client_payments_get


        """
        a = auth_random_a(usage_count_gt=0)
        ret = self.api.home_agent_client_payments_get()
        assert (ret.success )
        ret = self.api.home_agent_clients_get()
        auth()
        for cl in ret.payload.items:
            print(cl.client_id)
            PAYMENT_TYPE_DICT = {  # 1: 'n/a', 2: 'undefined',
                3: 'invoice payment sent',
                4: 'invoice payment received',
                5: 'prepay payment received',
                6: 'payment sent',
                7: 'credit note received',
                8: 'credit note sent',
                9: 'reset',
                # 10: 'offset',
                11: 'debit received',
                12: 'debit sent',
                #13: 'mutual reset',
                #14: 'actual reset',
                # 15: 'prepayment'
            }
            id = cl.client_id

            c = cli_dnl.CarrierApi().carrier_client_id_get(client_id=id).payload
            print(c.actual_balance, c.mutual_balance)

            pt = random.choice(tuple(PAYMENT_TYPE_DICT.values()))
            data = dict(
                payment_type=pt,
                # payment_type='prepay payment received',
                note=pt + ' ' + bla(6) + ' ' + dig(6),
                paid_on=datetime.now() - timedelta(hours=random.randint(1, 128)),
                amount=round(random.random() * 1000, 2)
            )
            print(id, data)
            ret1 = cli_dnl.FinanceApi().carrier_client_id_payment_post(client_id=id, body=data)
            assert(ret1.success)
        a = auth_a(agent_id=a.agent_id)
        order = ['client_id','client_name','invoice_number','payment_type_name','paid_on','amount']
        o = random.choice(order)
        for o in order:
            lst = self.api.home_agent_client_payments_get(order_by=o, order_dir=random.choice(['asc', 'desc']))
            assert (ret.success and len(ret.payload.items))
        ret = self.api.home_agent_client_payments_get()
        assert (ret.success and len(ret.payload.items))
        print(ret)
        print(a)


        pass

    def test_home_agent_clients_get(self):
        """
        Test case for home_agent_clients_get

        
        """
        a=auth_random_a(usage_count_gt=0)
        ret=self.api.home_agent_clients_get(order_by='mode')
        assert(ret.success and len(ret.payload.items))
        print(ret)

        ret=cli_dnl.AuthApi().user_get()
        assert(ret.success and ret.payload.user_type=='agent')

        ret=cli_dnl.CarrierApi().carrier_simple_list_get()
        assert(ret.success)
        ret = cli_dnl.TrunkApi().trunk_list_get()
        assert (ret.success)
        pass

    def test_home_agent_download_token_get(self):
        """
        Test case for home_agent_download_token_get


        """
        pass

    def test_home_agent_invoice_list_get(self):
        """
        Test case for home_agent_invoice_list_get


        """
        a = auth_random_a(usage_count_gt=0)
        ret = self.api.home_agent_invoice_list_get()
        assert (ret.success)
        pass

    def test_home_agent_products_get(self):
        """
        Test case for home_agent_products_get


        """
        a = auth_random_a(usage_count_gt=0)
        #a = auth_a(agent_id=18)
        #print(a)
        ret = self.api.home_agent_products_get(order_by='rate_table_name')
        assert (ret.success)# and len(ret.payload.items)==0)
        print(ret)
        pass

    def test_home_agent_rate_table_rate_table_id_download_get(self):
        """
        Test case for home_agent_rate_table_rate_table_id_download_get


        """
        pass

    def test_home_agent_rate_table_rate_table_id_list_get(self):
        """
        Test case for home_agent_rate_table_rate_table_id_list_get


        """
        a = auth_random_a()
        print(a)
        ret = self.api.home_agent_products_get()
        assert (ret.success and len(ret.payload.items))
        rtid = ret.payload.items[0].rate_table_id
        ret = self.api.home_agent_rate_table_rate_table_id_list_get(rate_table_id=rtid)
        assert (ret.success)
        print(ret)
        pass

    def test_home_agent_share_post(self):
        """
        Test case for home_agent_share_post


        """
        a = auth_random_a()
        print(a)
        ret = self.api.home_agent_share_post(body={'emails':'_novvv@mail.ru'})
        assert (ret.success)
        pass


if __name__ == '__main__':
    unittest.main()
