# coding: utf-8

"""
    DNL API

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: 1.3.44
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import os
import sys
import unittest

import cli_dnl
from cli_dnl.rest import ApiException
from cli_dnl.apis.trunk_api import TrunkApi
from . settings import *

def replace_action():
    dnis_length =random.randint(0,16)
    ani_length = random.randint(0, 16)
    return {
  'dnis_min_length': dnis_length,
  'ani_prefix': dig(7),
  'dnis_max_length': dnis_length + random.randint(0,16),
  'dnis_prefix': dig(8),
  'type': random.choice(['ani only replace the caller','dnis only replace the called',
            'both replace the calling and called']),
  'ani_min_length': ani_length,
  'ani': dig(16),
  'ani_max_length': ani_length+random.randint(0,32),
  'dnis':dig(16)
}

class TestTrunkApi(unittest.TestCase):
    """ TrunkApi unit test stubs """

    def setUp(self):
        self.api = cli_dnl.apis.trunk_api.TrunkApi()
        auth()
        ret = cli_dnl.CarrierApi().carrier_simple_list_get(email='_novvv@mail.ru')
        assert (ret.success)
        if len(ret.payload.items):
            self.client_id = ret.payload.items[0].client_id

    def tearDown(self):
        pass

    def test_trunk_digit_map_ref_id_delete(self):
        """
        Test case for trunk_digit_map_ref_id_delete

        
        """
        pass

    def test_trunk_digit_map_ref_id_get(self):
        """
        Test case for trunk_digit_map_ref_id_get

        
        """
        pass

    def test_trunk_digit_map_ref_id_patch(self):
        """
        Test case for trunk_digit_map_ref_id_patch

        
        """
        pass

    def test_trunk_direction_direction_id_delete(self):
        """
        Test case for trunk_direction_direction_id_delete

        
        """
        pass

    def test_trunk_direction_direction_id_get(self):
        """
        Test case for trunk_direction_direction_id_get

        
        """
        pass

    def test_trunk_direction_direction_id_patch(self):
        """
        Test case for trunk_direction_direction_id_patch

        
        """
        pass

    def test_trunk_egress_all_delete(self):
        """
        Test case for trunk_egress_all_delete


        """
        pass

    def test_trunk_egress_all_patch(self):
        """
        Test case for trunk_egress_all_patch


        """
        pass

    def test_trunk_egress_list_get(self):
        """
        Test case for trunk_egress_list_get

        
        """
        for dir in ['asc','desc']:
            for sort in ['resource_id','resource_template_id','is_active','carrier_id','trunk_id']:
                ret=self.api.trunk_egress_list_get(order_by=sort,order_dir=dir,per_page=3)
                assert (ret.success)
                #assert (ret.payload.items[0].egress)
        pass

    def test_trunk_egress_list_get_by_agent(self):
        """
        Test case for trunk_egress_list_get


        """
        a = auth_random_a(usage_count_gt=0)
        print(a.agent_id)
        ret = self.api.trunk_egress_list_get()
        assert (ret.success)
        print(ret)
        ret = self.api.trunk_ingress_list_get()
        assert (ret.success)
        print(ret)
        pass

    def test_trunk_egress_trunk_id_reapply_template_id_patch(self):
        """
        Test case for trunk_egress_trunk_id_reapply_template_id_patch


        """
        pass

    def test_trunk_egress_trunk_id_save_as_template_post(self):
        """
        Test case for trunk_egress_trunk_id_save_as_template_post

        
        """
        id=rand_trunk(direction='egress')[0]
        data={'name':'egress_template '+bla(8)}
        print('POST/trunk/{}/save_as_template'.format(id),json.dumps(data))
        ret=self.api.trunk_ingress_trunk_id_save_as_template_post(trunk_id=id,body=data)
        print(id,ret)
        assert(ret.success)
        pass

    def test_trunk_gatewaygroup_list_get(self):
        """
        Test case for trunk_gatewaygroup_list_get


        """
        for dir in ['asc','desc']:
            for sort in ['client_mode','alias','capacity','cps_limit','egress','ingress','resource_id',
            'client_id','client_name','client_allowed_credit','client_call_limit','client_cps_limit']:
                ret=self.api.trunk_gatewaygroup_list_get(order_by=sort,order_dir=dir,per_page=3)
                print(sort,dir,'success')
                assert (ret.success)
        pass

    def test_trunk_group_all_delete(self):
        """
        Test case for trunk_group_all_delete


        """
        pass

    def test_trunk_group_group_id_add_trunk_patch(self):
        """
        Test case for trunk_group_group_id_add_trunk_patch

        
        """

        pass

    def test_trunk_group_group_id_delete(self):
        """
        Test case for trunk_group_group_id_delete

        
        """
        pass

    def test_trunk_group_group_id_get(self):
        """
        Test case for trunk_group_group_id_get

        
        """
        pass

    def test_trunk_group_group_id_patch(self):
        """
        Test case for trunk_group_group_id_patch

        
        """
        auth()
        lst = self.api.trunk_group_list_get(per_page=50)
        assert (lst.success and len(lst.payload.items))

        ret = self.api.trunk_egress_list_get(per_page=50)
        assert (ret.success)
        random.shuffle(ret.payload.items)
        tr = []
        for i in range(0, random.randint(1,6)):
            tr.append(ret.payload.items[i].trunk_id)
        tr=list(set(tr))
        gr =random.choice(lst.payload.items)
        data = {'trunk_type': 'egress', 'group_name': gr.group_name, 'all_trunks': tr}
        print(json.dumps(data))
        ret = self.api.trunk_group_group_id_patch(group_id=gr.group_id,body=data)
        assert (ret.success)
        assert(len(ret.payload.trunks)==len(data['all_trunks']))
        for t in ret.payload.trunks:
            assert(t.trunk_id in data['all_trunks'])

        ret = self.api.trunk_ingress_list_get(per_page=50)
        assert (ret.success)
        random.shuffle(ret.payload.items)
        tr = []
        for i in range(0, random.randint(1,6)):
            tr.append(ret.payload.items[i].trunk_id)
        tr = list(set(tr))
        gr = random.choice(lst.payload.items)
        data = {'trunk_type': 'ingress', 'group_name': gr.group_name, 'all_trunks': tr}
        print(json.dumps(data))
        ret = self.api.trunk_group_group_id_patch(group_id=gr.group_id, body=data)
        assert (ret.success)
        assert (len(ret.payload.trunks) == len(data['all_trunks']))
        for t in ret.payload.trunks:
            assert(t.trunk_id in data['all_trunks'])

        pass

    def test_trunk_group_list_get(self):
        """
        Test case for trunk_group_list_get

        
        """
        ret=self.api.trunk_group_list_get()
        assert (ret.success)
        pass

    def test_trunk_group_post(self):
        """
        Test case for trunk_group_post

        
        """
        auth()
        try:
            data = {'trunk_type': 'egress'
                    , 'group_name': None
                    }
            print(json.dumps(data))
            ret = self.api.trunk_group_post(body=data)
            assert (not ret.success)
        except Exception as e:
            assert ('may not be null' in str(e))
        try:
            data = {'trunk_type': 'egress'

                    }
            ret = self.api.trunk_group_post(body=data)
            assert (not ret.success)
        except Exception as e:
            assert ('Missing' in str(e))

        ret=self.api.trunk_egress_list_get()
        assert(ret.success)

        tr=[]
        for i in range(0,5):
            tr.append(random.choice(ret.payload.items).trunk_id)

        data={'trunk_type':'egress','group_name':bla(7),'all_trunks':tr}
        print(json.dumps(data))
        ret=self.api.trunk_group_post(body=data)
        assert (ret.success)
        try:
            ret = self.api.trunk_group_post(body=data)
            assert (not ret.success)
        except Exception as e:
            assert ('already' in str(e))

        pass

    def test_trunk_igress_all_delete(self):
        """
        Test case for trunk_igress_all_delete


        """
        pass

    def test_trunk_igress_all_patch(self):
        """
        Test case for trunk_igress_all_patch


        """
        lst=rand_trunk(direction='ingress')[2]
        random.shuffle(lst)
        tr=','.join([str(lst[0].trunk_id),str(lst[1].trunk_id)])
        print(tr)
        ret=self.api.trunk_igress_all_patch(resource_id_in=tr,body={'active':True})
        assert(ret.success)

        pass

    def test_trunk_ingress_allowed_send_ip_id_get(self):
        """
        Test case for trunk_ingress_allowed_send_ip_id_get


        """
        pass

    def test_trunk_ingress_allowed_send_ip_id_patch(self):
        """
        Test case for trunk_ingress_allowed_send_ip_id_patch


        """
        id = 1
        pro = rand_switch_profile()[0]

        ret = self.api.trunk_ingress_allowed_send_ip_id_patch(id=id, body=dict(sip_profile_id=pro))
        assert(ret.success)
        print(ret)
        pass

    def test_trunk_ingress_list_get(self):
        """
        Test case for trunk_ingress_list_get

        
        """
        rp = rand_route_plan()[0]
        #rp=33
        ret = self.api.trunk_ingress_list_get(routing_plan_id=rp)
        assert (ret.success)
        #print(ret)
        #return
        for dir in ['asc','desc']:
            for sort in ['resource_id','resource_template_id','is_active',
                         'carrier_id','trunk_id','trunk_name','client_name']:
                ret=self.api.trunk_ingress_list_get(order_by=sort,order_dir=dir,per_page=3)
                assert (ret.success)

        pass

    def test_trunk_ingress_trunk_id_allowed_send_ip_create_post(self):
        """
        Test case for trunk_ingress_trunk_id_allowed_send_ip_create_post


        """
        pro = rand_switch_profile()[0]
        id = rand_trunk(direction='ingress')[0]
        ret = self.api.trunk_ingress_trunk_id_allowed_send_ip_create_post(trunk_id=id, body=dict(sip_profile_id=pro))
        assert (ret.success)
        pass

    def test_trunk_ingress_trunk_id_allowed_send_ip_delete(self):
        """
        Test case for trunk_ingress_trunk_id_allowed_send_ip_delete


        """

        pro = rand_switch_profile()[0]
        id = rand_trunk(direction='ingress')[0]
        ret = self.api.trunk_ingress_trunk_id_allowed_send_ip_create_post(trunk_id=id, body=dict(sip_profile_id=pro))
        ret = self.api.trunk_ingress_trunk_id_allowed_send_ip_delete(trunk_id=id)
        assert (ret.success)
        pass

    def test_trunk_ingress_trunk_id_allowed_send_ip_get(self):
        """
        Test case for trunk_ingress_trunk_id_allowed_send_ip_get


        """

        pro = rand_switch_profile()[0]
        id = rand_trunk(direction='ingress')[0]
        ret = self.api.trunk_ingress_trunk_id_allowed_send_ip_create_post(trunk_id=id, body=dict(sip_profile_id=pro))
        ret = self.api.trunk_ingress_trunk_id_allowed_send_ip_get(trunk_id=id)
        assert (ret.success)
        print(ret)
        pass

    def test_trunk_ingress_trunk_id_allowed_send_ip_patch(self):
        """
        Test case for trunk_ingress_trunk_id_allowed_send_ip_patch


        """
        pro = rand_switch_profile()[0]
        id = rand_trunk(direction='ingress')[0]
        ret = self.api.trunk_ingress_trunk_id_allowed_send_ip_create_post(trunk_id=id, body=dict(sip_profile_id=pro))
        ret = self.api.trunk_ingress_trunk_id_allowed_send_ip_patch(trunk_id=id,body=dict(sip_profile_id=pro))
        assert (ret.success)
        print(ret)
        pass

    def test_trunk_ingress_trunk_id_reapply_template_id_patch(self):
        """
        Test case for trunk_ingress_trunk_id_reapply_template_id_patch


        """
        pass

    def test_trunk_ingress_trunk_id_save_as_template_post(self):
        """
        Test case for trunk_ingress_trunk_id_save_as_template_post

        
        """
        id=rand_trunk(direction='ingress')[0]
        data={'name':'ingress_template_'+bla(8)}
        ret=self.api.trunk_ingress_trunk_id_save_as_template_post(trunk_id=id,body=data)
        assert(ret.success)
        pass

    def test_trunk_ip_limit_ext_list_get(self):
        """
        Test case for trunk_ip_limit_ext_list_get


        """
        for dir in ['asc','desc']:
            for sort in ['cps','capacity','resource_ip','resource_port','resource_active','resource_alias','resource_cps_limit','resource_capacity','client_name','client_call_limit','client_cps_limit']:
                ret=self.api.trunk_ip_limit_ext_list_get(order_by=sort,order_dir=dir,per_page=3)
                assert (ret.success)
                print(sort,'success')
        ret = self.api.trunk_ip_limit_ext_list_get()
        print(ret)
        assert (ret.success)
        pass

    def test_trunk_ip_limit_limit_id_delete(self):
        """
        Test case for trunk_ip_limit_limit_id_delete


        """
        lim = self.test_trunk_ip_resource_ip_id_limit_post()
        ret=self.api.trunk_ip_limit_limit_id_delete(limit_id=lim.object_id)
        assert(ret.success)
        pass

    def test_trunk_ip_limit_limit_id_get(self):
        """
        Test case for trunk_ip_limit_limit_id_get


        """
        lim = self.test_trunk_ip_resource_ip_id_limit_post()
        ret=self.api.trunk_ip_limit_limit_id_get(limit_id=lim.object_id)
        assert(ret.success)
        print(ret.payload.to_dict())

        ret1 = self.api.trunk_ip_limit_limit_id_delete(limit_id=lim.object_id)
        assert (ret1.success)
        pass

    def test_trunk_ip_limit_limit_id_patch(self):
        """
        Test case for trunk_ip_limit_limit_id_patch


        """
        lim = self.test_trunk_ip_resource_ip_id_limit_post()

        ret = self.api.trunk_ip_limit_limit_id_get(limit_id=lim.object_id)
        assert (ret.success)
        print(ret.payload.to_dict())

        data = {'cps': random.randint(0, 10000), 'capacity': random.randint(0, 10000),
                'time_profile_id': rand_time_profile()[0]
                }
        ret = self.api.trunk_ip_limit_limit_id_patch(limit_id=lim.object_id)
        assert (ret.success)
        print(data,ret.payload.to_dict())

        ret1 = self.api.trunk_ip_limit_limit_id_delete(limit_id=lim.object_id)
        assert (ret1.success)
        pass

    def test_trunk_ip_limit_list_get(self):
        """
        Test case for trunk_ip_limit_list_get


        """
        ret=self.api.trunk_ip_limit_list_get()
        assert(ret.success)
        pass

    def test_trunk_ip_list_get(self):
        """
        Test case for trunk_ip_list_get

        
        """
        ret=self.api.trunk_ip_list_get()
        assert(ret.success)
        id = rand_ip()[0]
        data = {'cps': random.randint(0, 10000), 'capacity': random.randint(0, 10000),
                'time_profile_id': rand_time_profile()[0]
                }
        ret = self.api.trunk_ip_resource_ip_id_limit_post(resource_ip_id=id, body=data)
        ret = self.api.trunk_ip_list_get(resource_ip_id=id)
        assert (ret.success)
        id = rand_ip()[0]
        data = {'cps': random.randint(0, 10000)
                }
        ret = self.api.trunk_ip_resource_ip_id_limit_post(resource_ip_id=id, body=data)
        ret = self.api.trunk_ip_list_get(resource_ip_id=id)
        assert (ret.success)
        pass

    def test_trunk_ip_resource_ip_id_delete(self):
        """
        Test case for trunk_ip_resource_ip_id_delete

        
        """
        ret = self.api.trunk_ip_list_get()
        assert (ret.success)
        id = random.choice(ret.payload.items).resource_ip_id
        ret=self.api.trunk_ip_resource_ip_id_delete(resource_ip_id=id)
        pass


    def test_trunk_ip_resource_ip_id_get(self):
        """
        Test case for trunk_ip_resource_ip_id_get

        
        """
        pass

    def test_trunk_ip_resource_ip_id_limit_post(self):
        """
        Test case for trunk_ip_resource_ip_id_limit_post


        """
        id=rand_ip()[0]
        data ={'cps':random.randint(0,10000),'capacity':random.randint(0,10000),
        #'time_profile_id':rand_time_profile()[0]
        }
        print(json.dumps(data))
        ret=self.api.trunk_ip_resource_ip_id_limit_post(resource_ip_id=id,body=data)
        assert(ret.success)
        print(ret)
        return ret
        pass

    def test_trunk_ip_resource_ip_id_limits_delete(self):
        """
        Test case for trunk_ip_resource_ip_id_limits_delete


        """
        pass

    def test_trunk_ip_resource_ip_id_limits_get(self):
        """
        Test case for trunk_ip_resource_ip_id_limits_get


        """
        pass

    def test_trunk_ip_resource_ip_id_limits_patch(self):
        """
        Test case for trunk_ip_resource_ip_id_limits_patch


        """
        pass

    def test_trunk_ip_resource_ip_id_patch(self):
        """
        Test case for trunk_ip_resource_ip_id_patch

        
        """
        pass

    def test_trunk_list_get(self):
        """
        Test case for trunk_list_get

        
        """
        ret = self.api.trunk_list_get(trunk_name='sourav123')
        assert (ret.success)
        print(ret)
        return
        for dir in ['asc','desc']:
            for sort in ['client_name','type','direction','active','carrier_id','trunk_id','trunk_name']:
                ret=self.api.trunk_list_get(order_by=sort,order_dir=dir,per_page=3)
                print(sort,dir,'success')
                assert (ret.success)
        pass

    def test_trunk_max_channels_get(self):
        """
        Test case for trunk_max_channels_get

        
        """
        pass

    def test_trunk_prefix_id_delete(self):
        """
        Test case for trunk_prefix_id_delete

        
        """
        pass

    def test_trunk_prefix_id_get(self):
        """
        Test case for trunk_prefix_id_get

        
        """
        pass

    def test_trunk_prefix_id_patch(self):
        """
        Test case for trunk_prefix_id_patch

        
        """
        pass

    def test_trunk_prefix_list_get(self):
        """
        Test case for trunk_prefix_list_get


        """
        for dir in ['asc','desc']:
            for sort in ['id','code', 'tech_prefix', 'rate_table_id', 'routing_plan_id', 'code_cps', 'code_cap',
                         'trunk_id','product_name','product_id','trunk_name']:
                ret = self.api.trunk_prefix_list_get(order_by=sort,order_dir=dir,per_page=3)
                assert(ret.success)
        pass

    def test_trunk_rate_summary_list_get(self):
        """
        Test case for trunk_rate_summary_list_get

        
        """
        ret = self.api.trunk_rate_summary_list_get(prefix_isnull=True)
        assert (ret.success)
        for dir in ['asc','desc']:
            for sort in ['trunk_name','carrier_name','rate_table_id','rate_table_name','prefix']:
                ret = self.api.trunk_rate_summary_list_get(order_by=sort,order_dir=dir,per_page=3)
                assert(ret.success)
        pass

    def test_trunk_replace_action_id_delete(self):
        """
        Test case for trunk_replace_action_id_delete

        
        """
        pass

    def test_trunk_replace_action_id_get(self):
        """
        Test case for trunk_replace_action_id_get

        
        """
        pass

    def test_trunk_replace_action_id_patch(self):
        """
        Test case for trunk_replace_action_id_patch

        
        """
        pass

    def test_trunk_trunk_id_assign_product_product_id_patch(self):
        """
        Test case for trunk_trunk_id_assign_product_product_id_patch

        
        """
        tid=rand_trunk(direction='ingress')[0]
        pid=rand_product()[0]
        ret=self.api.trunk_trunk_id_assign_product_product_id_patch(trunk_id=tid,product_id=pid)
        assert (ret.success)
        print(tid,pid)
        return
        print(ret)
        ret=cli_dnl.ProductApi().product_id_get(id=pid)
        print(ret)
        ret = cli_dnl.CarrierApi().ingress_trunk_resource_id_get(resource_id=tid)
        print(ret)

        pass

    def test_trunk_trunk_id_digit_map_id_time_profile_id_add_digit_map_post(self):
        """
        Test case for trunk_trunk_id_digit_map_id_time_profile_id_add_digit_map_post

        
        """
        pass

    def test_trunk_trunk_id_digit_map_list_get(self):
        """
        Test case for trunk_trunk_id_digit_map_list_get

        
        """
        id = rand_trunk()[0]
        ret = self.api.trunk_trunk_id_digit_map_list_get(trunk_id=id)
        assert (ret.success)
        pass

    def test_trunk_trunk_id_direction_list_get(self):
        """
        Test case for trunk_trunk_id_direction_list_get

        
        """
        id = rand_trunk()[0]
        ret = self.api.trunk_trunk_id_direction_list_get(trunk_id=id)
        assert (ret.success)
        pass

    def test_trunk_trunk_id_direction_post(self):
        """
        Test case for trunk_trunk_id_direction_post

        
        """
        pass

    def test_trunk_trunk_id_directions_patch(self):
        """
        Test case for trunk_trunk_id_directions_patch


        """
        id = rand_trunk()[0]
        data = {'directions':[]}
        for i in range(0,4):
            data['directions'].append(
            dict(time_profile_id = rand_time_profile()[0],
                action = random.choice(['plus prefix','plus suffix','minus prefix','minus suffix']),
                direction = random.choice(['ALL', 'ingress', 'egress']),
                digits = dig(5),
                dnis = dig(5),
                number_length = 5,
                number_type = random.choice(['all','greater than','equal to','less than']),
                type = random.choice(['modify the caller','modify the called'])
            ))
        print('/trunk/{}/directions'.format(id))
        print(json.dumps(data))
        ret=self.api.trunk_trunk_id_directions_patch(trunk_id=id,body=data)
        assert(ret.success)
        print(ret)
        pass

    def test_trunk_trunk_id_ip_post(self):
        """
        Test case for trunk_trunk_id_ip_post

        
        """
        pass

    def test_trunk_trunk_id_prefix_list_get(self):
        """
        Test case for trunk_trunk_id_prefix_list_get

        
        """
        id = rand_trunk()[0]
        ret = self.api.trunk_trunk_id_prefix_list_get(trunk_id=id)
        assert (ret.success)
        pass

    def test_trunk_trunk_id_prefix_post(self):
        """
        Test case for trunk_trunk_id_prefix_post

        
        """
        pass

    def test_trunk_trunk_id_replace_action_list_get(self):
        """
        Test case for trunk_trunk_id_replace_action_list_get

        
        """
        id=rand_trunk()[0]
        ret=self.api.trunk_trunk_id_replace_action_list_get(trunk_id=id)
        assert (ret.success)
        pass

    def test_trunk_trunk_id_replace_action_post(self):
        """
        Test case for trunk_trunk_id_replace_action_post

        
        """
        id = rand_trunk()[0]
        data = replace_action()
        ret = self.api.trunk_trunk_id_replace_action_post(trunk_id=id,body=data)
        assert (ret.success)
        try:
            data['type']=bla()
            ret = self.api.trunk_trunk_id_replace_action_post(trunk_id=id, body=data)
            assert (not ret.success)
        except Exception as e:
            assert('Not a valid value' in str(e))
        ret = self.api.trunk_trunk_id_replace_action_list_get(trunk_id=id)
        assert (ret.success and len(ret.payload.items)>=1)
        pass

    def test_trunk_trunk_id_replace_actions_patch(self):
        """
        Test case for trunk_trunk_id_replace_actions_patch


        """
        a=[]
        for i in range(0,5):
            l1=random.randint(1,10)
            l2 = random.randint(1, 10)
            a.append({
                'ani':dig(5),
                'ani_prefix': dig(5),
                'ani_max_length': l1+random.randint(1, 10),
                'ani_min_length': l1,
                'dnis_prefix': dig(5),
                'dnis': dig(5),
                'type': random.choice(['ani only replace the caller','dnis only replace the called',
                            'both replace the calling and called']),
                'dnis_min_length': l2,
                'dnis_max_length': l2+random.randint(1, 10)
            })
        id=rand_trunk()[0]
        data=dict(replace_actions=a)
        ret = self.api.trunk_trunk_id_replace_actions_patch(trunk_id=id,body=data)
        assert(ret.success)
        print(ret)
        pass

    def test_trunk_trunk_id_send_interop_patch(self):
        """
        Test case for trunk_trunk_id_send_interop_patch

        
        """
        id=rand_client()[0]
        ret=self.api.trunk_list_get(carrier_id=id)
        assert(ret.success and len(ret.payload.items))
        for tr in ret.payload.items:
            r=self.api.trunk_trunk_id_send_interop_patch(trunk_id=tr.trunk_id)
            assert (r.success)
        pass

    def test_trunk_unclaimed_list_get(self):
        """
        Test case for trunk_unclaimed_list_get

        
        """
        for order in ['type','rate_table_id','direction','active','carrier_id','trunk_id','trunk_name',
                      'rate_table_name','update_at']:
            for dir in ['asc','desc']:
                ret = self.api.trunk_unclaimed_list_get(order_by=order,order_dir=dir)
                assert(ret.success)

        pass


if __name__ == '__main__':
    unittest.main()
